/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifndef __KIRAN_AUTHENTICATION_GEN_H__
#define __KIRAN_AUTHENTICATION_GEN_H__

#include <gio/gio.h>

G_BEGIN_DECLS


/* ------------------------------------------------------------------------ */
/* Declarations for com.kylinsec.Kiran.SystemDaemon.Authentication */

#define KIRAN_TYPE_AUTHENTICATION_GEN (kiran_authentication_gen_get_type ())
#define KIRAN_AUTHENTICATION_GEN(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), KIRAN_TYPE_AUTHENTICATION_GEN, KiranAuthenticationGen))
#define KIRAN_IS_AUTHENTICATION_GEN(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), KIRAN_TYPE_AUTHENTICATION_GEN))
#define KIRAN_AUTHENTICATION_GEN_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE ((o), KIRAN_TYPE_AUTHENTICATION_GEN, KiranAuthenticationGenIface))

struct _KiranAuthenticationGen;
typedef struct _KiranAuthenticationGen KiranAuthenticationGen;
typedef struct _KiranAuthenticationGenIface KiranAuthenticationGenIface;

struct _KiranAuthenticationGenIface
{
  GTypeInterface parent_iface;


  gboolean (*handle_create_auth) (
    KiranAuthenticationGen *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_response_message) (
    KiranAuthenticationGen *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_message,
    const gchar *arg_sid);

  gboolean (*handle_start_auth) (
    KiranAuthenticationGen *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_username,
    const gchar *arg_sid,
    gint arg_type_op,
    gboolean arg_occupy);

  gboolean (*handle_stop_auth) (
    KiranAuthenticationGen *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_sid);

  void (*auth_messages) (
    KiranAuthenticationGen *object,
    const gchar *arg_message,
    gint arg_type,
    const gchar *arg_sid);

  void (*auth_method_changed) (
    KiranAuthenticationGen *object,
    gint arg_method,
    const gchar *arg_sid);

  void (*auth_status) (
    KiranAuthenticationGen *object,
    const gchar *arg_username,
    gint arg_state,
    const gchar *arg_sid);

};

GType kiran_authentication_gen_get_type (void) G_GNUC_CONST;

GDBusInterfaceInfo *kiran_authentication_gen_interface_info (void);
guint kiran_authentication_gen_override_properties (GObjectClass *klass, guint property_id_begin);


/* D-Bus method call completion functions: */
void kiran_authentication_gen_complete_create_auth (
    KiranAuthenticationGen *object,
    GDBusMethodInvocation *invocation,
    const gchar *sid,
    const gchar *pkey);

void kiran_authentication_gen_complete_start_auth (
    KiranAuthenticationGen *object,
    GDBusMethodInvocation *invocation);

void kiran_authentication_gen_complete_stop_auth (
    KiranAuthenticationGen *object,
    GDBusMethodInvocation *invocation);

void kiran_authentication_gen_complete_response_message (
    KiranAuthenticationGen *object,
    GDBusMethodInvocation *invocation);



/* D-Bus signal emissions functions: */
void kiran_authentication_gen_emit_auth_status (
    KiranAuthenticationGen *object,
    const gchar *arg_username,
    gint arg_state,
    const gchar *arg_sid);

void kiran_authentication_gen_emit_auth_messages (
    KiranAuthenticationGen *object,
    const gchar *arg_message,
    gint arg_type,
    const gchar *arg_sid);

void kiran_authentication_gen_emit_auth_method_changed (
    KiranAuthenticationGen *object,
    gint arg_method,
    const gchar *arg_sid);



/* D-Bus method calls: */
void kiran_authentication_gen_call_create_auth (
    KiranAuthenticationGen *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean kiran_authentication_gen_call_create_auth_finish (
    KiranAuthenticationGen *proxy,
    gchar **out_sid,
    gchar **out_pkey,
    GAsyncResult *res,
    GError **error);

gboolean kiran_authentication_gen_call_create_auth_sync (
    KiranAuthenticationGen *proxy,
    gchar **out_sid,
    gchar **out_pkey,
    GCancellable *cancellable,
    GError **error);

void kiran_authentication_gen_call_start_auth (
    KiranAuthenticationGen *proxy,
    const gchar *arg_username,
    const gchar *arg_sid,
    gint arg_type_op,
    gboolean arg_occupy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean kiran_authentication_gen_call_start_auth_finish (
    KiranAuthenticationGen *proxy,
    GAsyncResult *res,
    GError **error);

gboolean kiran_authentication_gen_call_start_auth_sync (
    KiranAuthenticationGen *proxy,
    const gchar *arg_username,
    const gchar *arg_sid,
    gint arg_type_op,
    gboolean arg_occupy,
    GCancellable *cancellable,
    GError **error);

void kiran_authentication_gen_call_stop_auth (
    KiranAuthenticationGen *proxy,
    const gchar *arg_sid,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean kiran_authentication_gen_call_stop_auth_finish (
    KiranAuthenticationGen *proxy,
    GAsyncResult *res,
    GError **error);

gboolean kiran_authentication_gen_call_stop_auth_sync (
    KiranAuthenticationGen *proxy,
    const gchar *arg_sid,
    GCancellable *cancellable,
    GError **error);

void kiran_authentication_gen_call_response_message (
    KiranAuthenticationGen *proxy,
    const gchar *arg_message,
    const gchar *arg_sid,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean kiran_authentication_gen_call_response_message_finish (
    KiranAuthenticationGen *proxy,
    GAsyncResult *res,
    GError **error);

gboolean kiran_authentication_gen_call_response_message_sync (
    KiranAuthenticationGen *proxy,
    const gchar *arg_message,
    const gchar *arg_sid,
    GCancellable *cancellable,
    GError **error);



/* ---- */

#define KIRAN_TYPE_AUTHENTICATION_GEN_PROXY (kiran_authentication_gen_proxy_get_type ())
#define KIRAN_AUTHENTICATION_GEN_PROXY(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), KIRAN_TYPE_AUTHENTICATION_GEN_PROXY, KiranAuthenticationGenProxy))
#define KIRAN_AUTHENTICATION_GEN_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), KIRAN_TYPE_AUTHENTICATION_GEN_PROXY, KiranAuthenticationGenProxyClass))
#define KIRAN_AUTHENTICATION_GEN_PROXY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), KIRAN_TYPE_AUTHENTICATION_GEN_PROXY, KiranAuthenticationGenProxyClass))
#define KIRAN_IS_AUTHENTICATION_GEN_PROXY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), KIRAN_TYPE_AUTHENTICATION_GEN_PROXY))
#define KIRAN_IS_AUTHENTICATION_GEN_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), KIRAN_TYPE_AUTHENTICATION_GEN_PROXY))

typedef struct _KiranAuthenticationGenProxy KiranAuthenticationGenProxy;
typedef struct _KiranAuthenticationGenProxyClass KiranAuthenticationGenProxyClass;
typedef struct _KiranAuthenticationGenProxyPrivate KiranAuthenticationGenProxyPrivate;

struct _KiranAuthenticationGenProxy
{
  /*< private >*/
  GDBusProxy parent_instance;
  KiranAuthenticationGenProxyPrivate *priv;
};

struct _KiranAuthenticationGenProxyClass
{
  GDBusProxyClass parent_class;
};

GType kiran_authentication_gen_proxy_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KiranAuthenticationGenProxy, g_object_unref)
#endif

void kiran_authentication_gen_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
KiranAuthenticationGen *kiran_authentication_gen_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error);
KiranAuthenticationGen *kiran_authentication_gen_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);

void kiran_authentication_gen_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
KiranAuthenticationGen *kiran_authentication_gen_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error);
KiranAuthenticationGen *kiran_authentication_gen_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);


/* ---- */

#define KIRAN_TYPE_AUTHENTICATION_GEN_SKELETON (kiran_authentication_gen_skeleton_get_type ())
#define KIRAN_AUTHENTICATION_GEN_SKELETON(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), KIRAN_TYPE_AUTHENTICATION_GEN_SKELETON, KiranAuthenticationGenSkeleton))
#define KIRAN_AUTHENTICATION_GEN_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), KIRAN_TYPE_AUTHENTICATION_GEN_SKELETON, KiranAuthenticationGenSkeletonClass))
#define KIRAN_AUTHENTICATION_GEN_SKELETON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), KIRAN_TYPE_AUTHENTICATION_GEN_SKELETON, KiranAuthenticationGenSkeletonClass))
#define KIRAN_IS_AUTHENTICATION_GEN_SKELETON(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), KIRAN_TYPE_AUTHENTICATION_GEN_SKELETON))
#define KIRAN_IS_AUTHENTICATION_GEN_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), KIRAN_TYPE_AUTHENTICATION_GEN_SKELETON))

typedef struct _KiranAuthenticationGenSkeleton KiranAuthenticationGenSkeleton;
typedef struct _KiranAuthenticationGenSkeletonClass KiranAuthenticationGenSkeletonClass;
typedef struct _KiranAuthenticationGenSkeletonPrivate KiranAuthenticationGenSkeletonPrivate;

struct _KiranAuthenticationGenSkeleton
{
  /*< private >*/
  GDBusInterfaceSkeleton parent_instance;
  KiranAuthenticationGenSkeletonPrivate *priv;
};

struct _KiranAuthenticationGenSkeletonClass
{
  GDBusInterfaceSkeletonClass parent_class;
};

GType kiran_authentication_gen_skeleton_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KiranAuthenticationGenSkeleton, g_object_unref)
#endif

KiranAuthenticationGen *kiran_authentication_gen_skeleton_new (void);


G_END_DECLS

#endif /* __KIRAN_AUTHENTICATION_GEN_H__ */
